From 25e67a6787237e97fef12e6428089cf75ae852c3 Mon Sep 17 00:00:00 2001
From: Eric Barbour <ebarbour@redhat.com>
Date: Jun 14 2016 16:16:43 +0000
Subject: [PATCH 490/1001] Add fedmsg/markup route, and api tests


---

diff --git a/hubs/app.py b/hubs/app.py
index fe661ab..df33459 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -1,11 +1,15 @@
 import datetime
 import functools
+import json
 import logging
 import os
+import uuid
 
 import flask
 import flask.json
+import fmn.lib
 import munch
+import pygments.formatters
 import six
 
 from flask.ext.openid import OpenID
@@ -16,6 +20,10 @@ import hubs.widgets
 import datanommer.models
 
 from hubs.utils import username2avatar
+from hubs.widgets.feed import (
+    apply_markup, rehydrate_preference,
+    get_remote_preference
+)
 
 app = flask.Flask(__name__)
 
@@ -43,6 +51,7 @@ import fedmsg.config
 import fedmsg.meta
 fedmsg_config = fedmsg.config.load_config()
 fedmsg.meta.make_processors(**fedmsg_config)
+PATHS = fmn.lib.load_rules(root='fmn.rules')
 
 session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'])
 datanommer.models.init(fedmsg_config['datanommer.sqlalchemy.uri'])
@@ -628,3 +637,50 @@ def hub_leave(hub):
         return flask.abort(400)
     session.commit()
     return flask.redirect(flask.url_for('hub', name=hub.name))
+
+
+@app.route('/api/fedmsg/markup', methods=['GET'])
+def markup_fedmsg():
+    try:
+        data = flask.request.args['message']
+        plugin = flask.request.args['plugin']
+    except KeyError:
+        return flask.abort(400)
+    widget = hubs.models.Widget.by_plugin(session, plugin)
+    if not widget:
+        return flask.abort(400)
+    context = widget.config.get('fmn_context')
+    messages = []
+    message = json.loads(data)
+    try:
+        nickname = flask.g.auth.nickname
+    except AttributeError:      # Not logged in
+        return flask.abort(403)
+    preference = get_remote_preference(nickname, context)
+    if preference:
+        try:
+            preference = rehydrate_preference(preference)
+        except ImportError:
+            pass
+    recipients = fmn.lib.recipients(
+        [preference], message, PATHS, fedmsg_config)
+    if recipients:
+        messages.append(message)
+    matches = fedmsg.meta.conglomerate(messages, lexers=True, **fedmsg_config)
+    for match in matches:
+        match['markup'] = apply_markup(match)
+        for _, constituent in match['msg_ids'].items():
+            constituent['markup'] = apply_markup(constituent)
+            if constituent['long_form'] != constituent['subtitle']:
+                if constituent.get('lexer'):
+                    constituent['long_form'] = pygments.highlight(
+                        constituent['long_form'],
+                        constituent['lexer'],
+                        pygments.formatters.HtmlFormatter(style='monokai'),
+                    )
+                else:
+                    markup = u"<h5>{long_form}</h5>".format(**constituent)
+                    constituent['long_form'] = markup
+        # And tack on a unique identifier for each top level entry.
+        match['dom_id'] = six.text_type(uuid.uuid4())
+    return flask.jsonify(matches)
diff --git a/hubs/models.py b/hubs/models.py
index 1731076..32580a6 100755
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -303,6 +303,10 @@ class Widget(BASE):
     def by_idx(cls, session, idx):
         return session.query(cls).filter_by(idx=idx).first()
 
+    @classmethod
+    def by_plugin(cls, session, plugin):
+        return session.query(cls).filter_by(plugin=plugin).first()
+
     get = by_idx
 
     @property
diff --git a/hubs/tests/__init__.py b/hubs/tests/__init__.py
index 8dbca6c..7c9da28 100644
--- a/hubs/tests/__init__.py
+++ b/hubs/tests/__init__.py
@@ -88,6 +88,22 @@ class APPTest(unittest.TestCase):
 
 
 @contextmanager
+def user_set(APP, user):
+    """ Set the provided user as fas_user in the provided application."""
+    # Hack used to remove the before_request function set by
+    # flask.ext.fas_openid.FAS which otherwise kills our effort to set a
+    # flask.g.fas_user.
+    from flask import appcontext_pushed, g
+
+    def handler(sender, **kwargs):
+        g.fas_user = user
+        g.fas_session_id = b'123'
+
+    with appcontext_pushed.connected_to(handler, APP):
+        yield
+
+
+@contextmanager
 def auth_set(APP, auth):
     """ Set the provided user as fas_user in the provided application."""
 
@@ -105,6 +121,7 @@ def auth_set(APP, auth):
     with appcontext_pushed.connected_to(handler, APP):
         yield
 
+
 class FakeUser(object):
     """ Fake user used to test the fedocallib library. """
 
diff --git a/hubs/tests/test_api/test_fedmsg.py b/hubs/tests/test_api/test_fedmsg.py
new file mode 100644
index 0000000..c708073
--- /dev/null
+++ b/hubs/tests/test_api/test_fedmsg.py
@@ -0,0 +1,330 @@
+import json
+
+import hubs.tests
+import hubs.models
+
+
+class TestFeed(hubs.tests.APPTest):
+    # TODO this test relies on a specific filter for the atelic user
+    # It would be better to fake preferences on FAS
+    user = hubs.tests.FakeAuthorization('atelic')
+    message_involved = {
+        'timestamp': 1465567413.0,
+        'topic': 'io.pagure.prod.pagure.issue.new',
+        'msg_id': '2016-0490127f-473f-4d01-ASDF-a864a56dc302',
+        'msg': {
+            'action': 'created',
+            'comment': {
+                'body':
+                'hm, there is something odd, the stackage page is being inconsistent, one time the version number for LTS is linked, one time it isn\'t.\r\n\r\nIt\'s as if there are 2 servers running 2 different versions of the application',
+                'created_at': '2016-06-10T14:03:31Z',
+                'html_url':
+                'https://github.com/fedora-infra/anitya/issues/283#issuecomment-225190438',
+                'id': 225190438,
+                'updated_at': '2016-06-10T14:03:31Z',
+                'url':
+                'https://api.github.com/repos/fedora-infra/anitya/issues/comments/225190438',
+                'user': {
+                    'gravatar_id': '',
+                    'html_url': 'https://github.com/pypingou',
+                    'id': 1240038,
+                    'login': 'pypingou',
+                    'site_admin': False,
+                    'type': 'User',
+                    'url': 'https://api.github.com/users/pypingou'
+                }
+            },
+            'fas_usernames': {
+                'fedora-infra': 'github_org_fedora-infra',
+                'pypingou': 'pingou'
+            },
+            'issue': {
+                'assignee': None,
+                'body':
+                '@juhp it seems that the stackage backend is broken: https://release-monitoring.org/projects/updates/failed?name=&log=stackage want to look at it?',
+                'closed_at': '2016-04-29T14:53:10Z',
+                'comments': 8,
+                'created_at': '2016-04-15T16:15:57Z',
+                'html_url':
+                'https://github.com/fedora-infra/anitya/issues/283',
+                'id': 148703615,
+                'labels': [],
+                'locked': False,
+                'milestone': None,
+                'number': 283,
+                'state': 'closed',
+                'title': 'stackage backend broken',
+                'updated_at': '2016-06-10T14:03:31Z',
+                'url':
+                'https://api.github.com/repos/fedora-infra/anitya/issues/283',
+                'user': {
+                    'gravatar_id': '',
+                    'html_url': 'https://github.com/pypingou',
+                    'id': 1240038,
+                    'login': 'pypingou',
+                    'site_admin': False,
+                    'type': 'User',
+                    'url': 'https://api.github.com/users/pypingou'
+                }
+            },
+            'organization': {
+                'description': 'Fedora Infrastructure Team',
+                'id': 3316637,
+                'login': 'fedora-infra',
+                'url': 'https://api.github.com/orgs/fedora-infra'
+            },
+            'repository': {
+                'created_at': '2013-11-29T10:17:26Z',
+                'default_branch': 'master',
+                'description': 'A cross-distribution upstream release project',
+                'fork': False,
+                'forks': 33,
+                'forks_count': 33,
+                'full_name': 'fedora-infra/anitya',
+                'has_downloads': True,
+                'has_issues': True,
+                'has_pages': False,
+                'has_wiki': False,
+                'homepage': 'https://release-monitoring.org',
+                'html_url': 'https://github.com/fedora-infra/anitya',
+                'id': 14798348,
+                'language': 'Python',
+                'name': 'anitya',
+                'open_issues': 25,
+                'open_issues_count': 25,
+                'owner': {
+                    'gravatar_id': '',
+                    'html_url': 'https://github.com/fedora-infra',
+                    'id': 3316637,
+                    'login': 'fedora-infra',
+                    'site_admin': False,
+                    'type': 'Organization',
+                    'url': 'https://api.github.com/users/fedora-infra'
+                },
+                'private': False,
+                'pushed_at': '2016-06-05T18:16:15Z',
+                'size': 4364,
+                'stargazers_count': 56,
+                'updated_at': '2016-06-10T09:43:58Z',
+                'url': 'https://api.github.com/repos/fedora-infra/anitya',
+                'watchers': 56,
+                'watchers_count': 56
+            },
+            'sender': {
+                'gravatar_id': '',
+                'html_url': 'https://github.com/pypingou',
+                'id': 1240038,
+                'login': 'pypingou',
+                'site_admin': False,
+                'type': 'User',
+                'url': 'https://api.github.com/users/pypingou'
+            }
+        },
+        'arguments': {
+            'categories': [
+                'pagure'
+            ],
+            'contains': [],
+            'delta': 172800.0,
+            'end': 1465839365.0,
+            'grouped': False,
+            'meta': [],
+            'not_categories': [],
+            'not_packages': [],
+            'not_topics': [],
+            'not_users': [],
+            'order': 'desc',
+            'packages': [],
+            'page': 1,
+            'rows_per_page': 1,
+            'start': 1465666565.0,
+            'topics': [],
+            'users': []
+        },
+        'count': 1,
+        'pages': 225,
+        'total': 225
+    }
+    message_not_involved = {
+        'topic': 'org.fedoraproject.prod.github.issue.comment',
+        'i': 1,
+        'msg': {
+            'action': 'created',
+            'comment': {
+                'body':
+                'hm, there is something odd, the stackage page is being inconsistent, one time the version number for LTS is linked, one time it isn\'t.\r\n\r\nIt\'s as if there are 2 servers running 2 different versions of the application',
+                'created_at': '2016-06-10T14:03:31Z',
+                'html_url':
+                'https://github.com/fedora-infra/anitya/issues/283#issuecomment-225190438',
+                'id': 225190438,
+                'updated_at': '2016-06-10T14:03:31Z',
+                'url':
+                'https://api.github.com/repos/fedora-infra/anitya/issues/comments/225190438',
+                'user': {
+                    'gravatar_id': '',
+                    'html_url': 'https://github.com/pypingou',
+                    'id': 1240038,
+                    'login': 'pypingou',
+                    'site_admin': False,
+                    'type': 'User',
+                    'url': 'https://api.github.com/users/pypingou'
+                }
+            },
+            'fas_usernames': {
+                'fedora-infra': 'github_org_fedora-infra',
+                'pypingou': 'pingou'
+            },
+            'issue': {
+                'assignee': None,
+                'body':
+                '@juhp it seems that the stackage backend is broken: https://release-monitoring.org/projects/updates/failed?name=&log=stackage want to look at it?',
+                'closed_at': '2016-04-29T14:53:10Z',
+                'comments': 8,
+                'created_at': '2016-04-15T16:15:57Z',
+                'html_url':
+                'https://github.com/fedora-infra/anitya/issues/283',
+                'id': 148703615,
+                'labels': [],
+                'locked': False,
+                'milestone': None,
+                'number': 283,
+                'state': 'closed',
+                'title': 'stackage backend broken',
+                'updated_at': '2016-06-10T14:03:31Z',
+                'url':
+                'https://api.github.com/repos/fedora-infra/anitya/issues/283',
+                'user': {
+                    'gravatar_id': '',
+                    'html_url': 'https://github.com/pypingou',
+                    'id': 1240038,
+                    'login': 'pypingou',
+                    'site_admin': False,
+                    'type': 'User',
+                    'url': 'https://api.github.com/users/pypingou'
+                }
+            },
+            'organization': {
+                'description': 'Fedora Infrastructure Team',
+                'id': 3316637,
+                'login': 'fedora-infra',
+                'url': 'https://api.github.com/orgs/fedora-infra'
+            },
+            'repository': {
+                'created_at': '2013-11-29T10:17:26Z',
+                'default_branch': 'master',
+                'description':
+                'A cross-distribution upstream release monitoring project',
+                'fork': False,
+                'forks': 33,
+                'forks_count': 33,
+                'full_name': 'fedora-infra/anitya',
+                'has_downloads': True,
+                'has_issues': True,
+                'has_pages': False,
+                'has_wiki': False,
+                'homepage': 'https://release-monitoring.org',
+                'html_url': 'https://github.com/fedora-infra/anitya',
+                'id': 14798348,
+                'language': 'Python',
+                'name': 'anitya',
+                'open_issues': 25,
+                'open_issues_count': 25,
+                'owner': {
+                    'gravatar_id': '',
+                    'html_url': 'https://github.com/fedora-infra',
+                    'id': 3316637,
+                    'login': 'fedora-infra',
+                    'site_admin': False,
+                    'type': 'Organization',
+                    'url': 'https://api.github.com/users/fedora-infra'
+                },
+                'private': False,
+                'pushed_at': '2016-06-05T18:16:15Z',
+                'size': 4364,
+                'stargazers_count': 56,
+                'updated_at': '2016-06-10T09:43:58Z',
+                'url': 'https://api.github.com/repos/fedora-infra/anitya',
+                'watchers': 56,
+                'watchers_count': 56
+            },
+            'sender': {
+                'gravatar_id': '',
+                'html_url': 'https://github.com/pypingou',
+                'id': 1240038,
+                'login': 'pypingou',
+                'site_admin': False,
+                'type': 'User',
+                'url': 'https://api.github.com/users/pypingou'
+            }
+        },
+        'msg_id': '2016-0490127f-473f-4d01-8e3a-a864a56dc302',
+        'signature':
+        'MNpAVdrPW78dcSe94FOS+/6QFBYo/LkrV5ee9tQedkhurHY1BGpaFHlU5l8cNVEpB7rr/zhHgQ+V\nmE3zYPmW/aREgvUoQgz74TR5F6/nK4Q1cD97VkFgHCadxZC6kjXd4H3BahEYnD+erj1iaArcdZaI\nXyKLZUBJLYL4JiXlmec=\n',
+        'source_name': 'datanommer',
+        'source_version': '0.6.5',
+        'timestamp': 1465567413.0,
+        'topic': 'org.fedoraproject.prod.github.issue.comment'
+    }
+
+    plugin = 'feed'
+
+    def test_returns_400_when_no_message(self):
+        payload = {'plugin': 'feed'}
+        response = self.app.get('/api/fedmsg/markup', query_string=payload)
+        assert response.status_code == 400
+
+    def test_returns_400_when_no_plugin(self):
+        payload = {'message': json.dumps(self.message_involved)}
+        response = self.app.get('/api/fedmsg/markup', query_string=payload)
+        assert response.status_code == 400
+
+    def test_returns_400_when_bad_plugin_name(self):
+        payload = {
+            'message': json.dumps(self.message_involved),
+            'plugin': 'notarealplugin'
+        }
+        response = self.app.get('/api/fedmsg/markup', query_string=payload)
+        assert response.status_code == 400
+
+    def test_returns_403_when_not_logged_in(self):
+        payload = {
+            'message': json.dumps(self.message_involved),
+            'plugin': 'feed'
+        }
+        with hubs.tests.user_set(self.app, self.user):
+            response = self.app.get('/api/fedmsg/markup', query_string=payload)
+
+            assert response.status_code == 403
+
+    def test_returns_match_if_involved(self):
+        payload = {
+            'message': json.dumps(self.message_involved),
+            'plugin': 'feed'
+        }
+        with self.app.session_transaction() as sess:
+            sess['openid'] = 'atelic@fedoraproject.org'
+            sess['nickname'] = 'atelic'
+
+        with hubs.tests.user_set(self.app, self.user):
+            response = self.app.get('/api/fedmsg/markup', query_string=payload)
+
+            assert response.status_code == 200, response.status_code
+            data = json.loads(response.data)
+            self.assertTrue(data)
+            assert isinstance(data[0], dict)
+
+    def test_returns_no_match_if_not_involved(self):
+        payload = {
+            'message': json.dumps(self.message_not_involved),
+            'plugin': 'feed'
+        }
+        with self.app.session_transaction() as sess:
+            sess['openid'] = 'atelic@fedoraproject.org'
+            sess['nickname'] = 'atelic'
+
+        with hubs.tests.user_set(self.app, self.user):
+            response = self.app.get('/api/fedmsg/markup', query_string=payload)
+
+            assert response.status_code == 200, response.status_code
+            data = json.loads(response.data)
+            self.assertFalse(data)

